#include "pd8255.h"
#include "mc6847.h"
#include "intr.h"
#include "memory.h"
#include "pd8049.h"


/*
BASIC ROM[`
								// 8049AɃf[^󂯎
Z0323:	LD	A,0CH		;E78	// WIE(6)Lɂ ܂菑ݗv݋֎~ INT=RINTƂ邽?
		OUT	(093H),A	;E7A
								// Ԃ񂱂̕ӂ̃^C~O8049f[^o͂STB(4)=LɂB
								// PortA̓b`,obt@̂IBF(5)=HƂȂB
								// ɂ8049̓f[^o͂~,STB(4)=HɂB
								// STB(4)̗オINT(3)=HƂȂB
								//  IBF(5)=H -> INT(3)=H ̏ɑ҂̂?
Z0319:	IN	A,(092H)	;E7C
		AND	08H			;E7E	// INT(3)HɂȂ܂ő҂
		JR	Z,0E7CH		;E80	// ܂8049̃f[^PortAɃb`܂ő҂
		IN	A,(092H)	;E82
		AND	020H		;E84	// IBF(5)HɂȂ܂ő҂ INT=HHɂȂĂ
		JR	Z,0E7CH		;E86	// ܂PortA̓̓obt@܂ő҂
		LD	A,0DH		;E88	// WIE(6)Hɂ ܂菑ݗv݋
		OUT	(093H),A	;E8A
		IN	A,(090H)	;E8C	// PortAf[^󂯎
		RET				;E8E
		
								// Ãf[^8049֑
Z0044:	PUSH	AF		;E8F
		LD	A,08H		;E90	// RIE(4)Lɂ ܂Ǎݗv݋֎~ INT=WINTƂ邽?
		OUT	(093H),A	;E92
Z0320:	IN	A,(092H)	;E94
		AND	08H			;E96	// INT(3)HɂȂ܂ő҂
		JR	Z,0E94H		;E98	// ܂8049f[^󂯎ăobt@ɂȂ܂ő҂ O񑗂f[^?
		IN	A,(092H)	;E9A
		AND	080H		;E9C	// OBF(7)HɂȂ܂ő҂ INT=HHɂȂĂ
		JR	Z,0E94H		;E9E	// ܂8049f[^󂯎DAK=HɂȂ܂ő҂ O񑗂f[^?
		LD	A,09H		;EA0	// RIE(4)Hɂ ܂Ǎݗv݋
		OUT	(093H),A	;EA2
		POP	AF			;EA4
		OUT	(090H),A	;EA5	// PortAɃf[^𑗂
		RET				;EA7


y8255 [h2̋z
bit3 INT(o)	[͂̏ꍇ]̏o͂8049̃f[^PortA()Ƀb`ꂽƂHƂȂ
				CPUɑ΂f[^Ǎݗv荞ݐMƂēB
				[o͂̏ꍇ]̏o͂8049f[^󂯎HƂȂ,CPUɑ΂
				̃f[^̏ݗv荞ݐMƂēB

bit4 STB()	̓͂Lɂ8049PortAɑĂMPortAb`
				[]IBFLɂȂOSTBLɂȂƃ|[gb`f[^ωĂ܂B
				@@@STBIBFLɂȂ܂łHɕۂȂ΂ȂȂB
				[⑫]8049~WRɌqĂ炵B܂8049PortAɏo͂瑦b`B

bit5 IBF(o)	̏o͂H̎PortA̓̓obt@Ă邱ƂӖ,8049ɑ΂ăf[^̓]̋֎~m点B
				̐MSTB̗HƂȂSTB=1̎̃f[^ǍݏI(~RDオ)LɂȂB
				[hݒ蒼̏lLłB

bit6 DAK()	̓͂8049PortA(o)̃f[^󂯎ƂƂm点MłB
				f[^󂯎L̐Mo悤8049݌vB
				[⑫]8049~RDɌqĂ炵B܂8049PortA͂瑦DAK=LɂȂB

bit7 OBF(o)	̐MCPŨf[^PortA(o)Ƀb`ꂽLƂȂ,8049ɑ΂Ẵf[^󂯎vƂēB
				OBFDAK=1̂Ƃ̃f[^ݏI(~WRオ)LɂȂ8049f[^󂯎DAK̗HɂȂB
				[hݒ蒼̏lHłB
				[]OBFHɂȂOɃf[^݂̏sPortA(o)ωĂ܂̂,OBFL̊Ԃ͏݂͔B
				[⑫]8049INTɌqĂ炵B܂8049݂͊Ńf[^󂯎B


bit4 RIE		CPUɑ΂f[^Ǎݗv荞݂̋tO,̃rbgrbg얽߂1ɂ邱ƂɂĊ荞݋,
				0ɂ邱ƂɂĊ荞݋֎~ɂB
				RIEĂrbgɊ蓖ĂĂSTB̋@\ɂ͉e^ȂB

bit6 WIE		CPUɑ΂f[^ݗv荞݂̋tO,̃rbgrbg얽߂1ɂ邱ƂɂĊ荞݋,
				0ɂ邱ƂɂĊ荞݋֎~ɂB
				WIEĂrbgɊ蓖ĂĂDAK̋@\ɂ͉e^ȂB
*/


// nhVFCNprbg
#define	HS_INT	(0x08)	/* bit3 */
#define	HS_STB	(0x10)	/* bit4 */
#define	HS_IBF	(0x20)	/* bit5 */
#define	HS_DAK	(0x40)	/* bit6 */
#define	HS_OBF	(0x80)	/* bit7 */

#define	HS_RIE	(0x10)	/* bit4 */
#define	HS_WIE	(0x40)	/* bit6 */


////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
D8255::D8255( void )
{
	Reset();
}

PIO6::PIO6( VM6 *vm, const ID& id ) : P6DEVICE(vm,id), Device(id){}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
D8255::~D8255(){}
PIO6::~PIO6(){}


////////////////////////////////////////////////////////////////
// Zbg
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void D8255::Reset( void )
{
	// o
	PortA    = PortB    = PortC     = 0;
	ModeA    = ModeB    = 0;
	PortAdir = PortBdir = PortC1dir = PortC2dir = TRUE;
	
	HSINT0 = HSWINT0 = HSRINT0 = HSIBF0 = FALSE;
	HSSTB0 = HSDAK0 = HSOBF0 = TRUE;
	RIE0   = WIE0 = FALSE;
}


////////////////////////////////////////////////////////////////
// [hݒ
//
// :	data	f[^]
//				bit6,5: O[vÃ[h	1x:[h2 01:[h1 00:[h0
//				bit4:   PortA				1:(ǂ) 0:o()
//				bit3:   PortC(bit4-7)		1:(ǂ) 0:o()
//				bit2:   O[vB̃[h	1:[h1 0:[h0
//				bit1:   PortB				1:(ǂ) 0:o()
//				bit0:   PortC(bit0-3)		1:(ǂ) 0:o()
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void D8255::SetMode( BYTE data )
{
	ModeA     = (data>>6)&1 ? 2    : (data>>5)&1;
	ModeB     = (data>>2)&1;
	PortAdir  = (data>>4)&1 ? TRUE : FALSE;
	PortC2dir = (data>>3)&1 ? TRUE : FALSE;
	PortBdir  = (data>>1)&1 ? TRUE : FALSE;
	PortC1dir = (data   )&1 ? TRUE : FALSE;
	
	PortA = PortB = PortC = 0;
	if( ModeA == 2 ) PortC |= HS_OBF;
	
	PRINTD2( PPI_LOG, "[8255][SetMode] GrA:%d GrB:%d\n", ModeA, ModeB );
}


////////////////////////////////////////////////////////////////
// PartA Cg(ӑ)
//
// :	data	ރf[^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void D8255::WriteAE( BYTE data )
{
	PRINTD1( PPI_LOG, "[8255][WriteAE] %02X", data );
	
	// Ƃ肠[h2̏ꍇl
	if( ModeA == 2 ){
		// obt@Ƀf[^b`
		PortAbuf = data;
		// 
		if( HSSTB0 ){
			// IBF=H
			HSIBF0   = TRUE;
			
			PRINTD3( PPI_LOG, " DOWN IBF:%d RINT:%d DATA:%02X", HSIBF0 ? 1 : 0, HSRINT0 ? 1 : 0, data );
		}
		HSSTB0 = FALSE;
		// 
		if( !HSSTB0 ){
			// IBF=H ȂRINT=H
			if( HSIBF0 ) HSRINT0 = TRUE;
			
			PRINTD2( PPI_LOG, " UP IBF:%d RINT:%d", HSIBF0 ? 1 : 0, HSRINT0 ? 1 : 0 );
		}
		HSSTB0 = TRUE;
	}
	
	PRINTD( PPI_LOG, "\n" );
}


////////////////////////////////////////////////////////////////
// PartA [h(ӑ)
//
// :	Ȃ
// Ԓl:	BYTE	PortA̒l
////////////////////////////////////////////////////////////////
BYTE D8255::ReadAE( void )
{
	PRINTD( PPI_LOG, "[8255][ReadAE]" );
	
	// Ƃ肠[h2̏ꍇl
	if( ModeA == 2 ){
		// ȂOBF=H
		if( HSDAK0 ){
			HSOBF0 = TRUE;
			
			PRINTD2( PPI_LOG, " DN OBF:%d WINT %d", HSOBF0 ? 1 : 0, HSWINT0 ? 1 : 0 );
		}
		HSDAK0 = FALSE;
		// 
		if( !HSDAK0 ){
			// OBF=H ȂWRINT=H
			if( HSOBF0 ) HSWINT0 = TRUE;
			
			PRINTD2( PPI_LOG, " UP OBF:%d WINT %d", HSOBF0 ? 1 : 0, HSWINT0 ? 1 : 0 );
		}
		HSDAK0 = TRUE;
	}
	
	PRINTD( PPI_LOG, "\n" );
	
	return PortA;
}


////////////////////////////////////////////////////////////////
// 
//
// :	Ȃ
// Ԓl:	BOOL	TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL D8255::Init( void )
{
	Reset();
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// PartA Cg
//
// :	data	ރf[^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void D8255::WriteA( BYTE data )
{
	PRINTD1( PPI_LOG, "[8255][WriteA] %02X", data );
	
	if( !PortAdir ){
		PortA = data;
		
		// Ƃ肠[h2̏ꍇl
		if( ModeA == 2 ){
			// WR0WINT=L
			HSWINT0 = FALSE;
			// WR0 DAK=H Ȃ OBF=L
			if( HSDAK0 ) HSOBF0 = FALSE;
			
			PRINTD2( PPI_LOG, " WINT:%d OBF %d\n", HSWINT0 ? 1 : 0, HSOBF0 ? 1 : 0 );
		}
		JobWriteA( PortA );
	}else{
		PRINTD( PPI_LOG, "\n" );
	}
}

void PIO6::JobWriteA( BYTE data )
{
	// [h2 DAK=H,OBF=L(܂WR0) Ȃ8049ɑ΂Ċݗv
	if( ModeA == 2 && HSDAK0 && !HSOBF0 )
		vm->subcpu->ExtIntr();
}


////////////////////////////////////////////////////////////////
// PartB Cg
//
// :	data	ރf[^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void D8255::WriteB( BYTE data )
{
	PRINTD1( PPI_LOG, "[8255][WriteB] %02X", data );
	
	if( !PortBdir ){
		PortB = data;
		JobWriteB( PortB );
	}
	
	PRINTD( PPI_LOG, "\n" );
}


////////////////////////////////////////////////////////////////
// PartC Cg
//
// :	data	ރf[^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void D8255::WriteC( BYTE data )
{
	PRINTD1( PPI_LOG, "[8255][WriteC] %02X", data );
	
	// ڏ݂̓[h0̎ɂ̂݉\
	
	// O[vA[h0   ʂbit0-3 ʂbit4-7
	//            [h1,2 ʂbit0-2 ʂbit3-7
	
	
	if( ModeA == 0 ){
		// O[vA[h0,O[vB[h1牺(bit0-3)}XN
		if( ModeB == 1 ) data = ( PortC & 0x0f ) | ( data & 0xf0 );
	}else{
		// O[vA[h1,2(bit3-7)}XN
		PortC = ( PortC & 0xf8 ) | ( data & 0x07 );
		// O[vA[h1,2,O[vB[h1Să}XN
		if( ModeB == 1 ) data = PortC;
	}
	
	// 
	if( !PortC1dir && ModeB == 0 ){
		if( ModeA == 0 ) PortC = ( PortC & 0xf0 ) | ( data & 0x0f );
		else             PortC = ( PortC & 0xf8 ) | ( data & 0x07 );
		JobWriteC1( PortC );
	}
	// 
	if( !PortC2dir && ModeA == 0 ){
		PortC = ( PortC & 0x07 ) | ( data & 0xf8 );
		JobWriteC2( PortC );
	}
	
	PRINTD( PPI_LOG, "\n" );
}

void PIO6::JobWriteC1( BYTE data )
{
	// v^Xg[u
	
	// CRT\ؑ
	vm->vdg->SetCrtDisp( data&2 ? TRUE : FALSE );
	
	// CG ROM BANK ؑ
	vm->mem->SetCGBank( data&4 ? FALSE : TRUE );
}


////////////////////////////////////////////////////////////////
// PartD Cg(Rg[|[g)
//
// :	data	ރf[^
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void D8255::WriteD( BYTE data )
{
	PRINTD1( PPI_LOG, "[8255][WriteD] %02X", data );
	
	if( data&0x80 ){	// ŏʃrbg1Ȃ
		// [hI
		SetMode( data );
	}else{				// ŏʃrbg0Ȃ
		// rbgZbg/Zbg
		// [h2őΏbitINT(bit3),IBF(bit5),OBF(bit7)̏ꍇ(̓|[gȂ̂)}XN
		// ̃[h̓m[PA
		if( ModeA == 2 ){
			// bit̑Ή
			switch( (data>>1)&0x07 ){
			case 4: // RIE0
				RIE0 = ( data&1 ) ? TRUE : FALSE;
				break;
			
			case 6: // WIE0
				WIE0 = ( data&1 ) ? TRUE : FALSE;
				break;
			
			case 3: // INT0
			case 5: // IBF0
			case 7: // OBF0
				break;
			
			default:	// ܂bit0-2
				if( data&1 ) PortC |=   1<<((data>>1)&0x07);
				else         PortC &= ~(1<<((data>>1)&0x07));
			}
		}else{
			if( data&1 ) PortC |=   1<<((data>>1)&0x07);
			else         PortC &= ~(1<<((data>>1)&0x07));
		}
		JobWriteD( data );
	}
	
	PRINTD( PPI_LOG, "\n" );
}

void PIO6::JobWriteD( BYTE data )
{
	// bit̑Ή
	switch( (data>>1)&0x07 ){
	case 0: // v^Xg[u
		break;
		
	case 1: // CRT\ؑ
		vm->vdg->SetCrtDisp( data&1 ? TRUE : FALSE );
		break;
		
	case 2: // CG ROM BANK ؑ
		vm->mem->SetCGBank( data&1 ? FALSE : TRUE );
		break;
	}
}


////////////////////////////////////////////////////////////////
// PartA [h
//
// :	Ȃ
// Ԓl:	BYTE	PortA̒l
////////////////////////////////////////////////////////////////
BYTE D8255::ReadA( void )
{
	// o̓|[gł̂܂ܓǍ߂
	
	JobReadA();
	// Ƃ肠[h2̏ꍇl
	if( ModeA == 2 ){
		// RD0RINT=L
		HSRINT0 = FALSE;
		
		// IBF=HȂobt@f[^Ǎ
		if( HSIBF0 ){
			PortA = PortAbuf;
		}
		
		// RD0 STB=H Ȃ IBF=L
		if( HSSTB0 ) HSIBF0 = FALSE;
	}
	
	PRINTD3( PPI_LOG, "[8255][Read][PortA] %02X STB:%d IBF:%d\n", PortA, HSSTB0, HSIBF0 );
	return PortA;
}


////////////////////////////////////////////////////////////////
// PartB [h
//
// :	Ȃ
// Ԓl:	BYTE	PortB̒l
////////////////////////////////////////////////////////////////
BYTE D8255::ReadB( void )
{
	// o̓|[gł̂܂ܓǍ߂
	
	JobReadB();
	return PortB;
}


////////////////////////////////////////////////////////////////
// PartC [h
//
// :	Ȃ
// Ԓl:	BYTE	PortC̒l
////////////////////////////////////////////////////////////////
BYTE D8255::ReadC( void )
{
	// o̓|[gł̂܂ܓǍ߂
	
	JobReadC();
	// Ƃ肠[h2̏ꍇl
	if( ModeA == 2 ){
		HSWINT0 = ( HSOBF0 && WIE0 && HSDAK0 ) ? TRUE : FALSE;
		HSRINT0 = ( HSIBF0 && RIE0 && HSSTB0 ) ? TRUE : FALSE;
		HSINT0  = ( HSWINT0 || HSRINT0 ) ? TRUE : FALSE;
		
		PortC = ( HSOBF0 ? HS_OBF : 0 ) | ( WIE0   ? HS_WIE : 0 ) | ( HSIBF0 ? HS_IBF : 0 ) |
				( RIE0   ? HS_RIE : 0 ) | ( HSINT0 ? HS_INT : 0 ) | ( PortC & 0x07 );
	}
	PRINTD5( PPI_LOG, "[8255][Read][PortC] OBF:%d WIE:%d IBF:%d RIE:%d INT:%d ", HSOBF0, WIE0, HSIBF0, RIE0, HSINT0  );
	PRINTD2( PPI_LOG, "WINT:%d RINT:%d\n", HSWINT0, HSRINT0 );
	return PortC;
}


////////////////////////////////////////////////////////////////
// IBF擾
//
// :	Ȃ
// Ԓl:	BOOL	Xe[^X
////////////////////////////////////////////////////////////////
BOOL D8255::GetIBF( void )
{
	// Ƃ肠[h2̏ꍇl
	if( ModeA == 2 ) return HSIBF0;
	
	return FALSE;
}


////////////////////////////////////////////////////////////////
// OBF擾
//
// :	Ȃ
// Ԓl:	BOOL	Xe[^X
////////////////////////////////////////////////////////////////
BOOL D8255::GetOBF( void )
{
	// Ƃ肠[h2̏ꍇl
	if( ModeA == 2 ) return HSOBF0;
	
	return FALSE;
}


////////////////////////////////////////////////////////////////
// ǂłSAVE
//
// :	Ini		INIIuWFNg|C^
// Ԓl:	BOOL	TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL PIO6::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "8255", NULL, "PortA",		"0x%02X",	PortA );
	Ini->PutEntry( "8255", NULL, "PortB",		"0x%02X",	PortB );
	Ini->PutEntry( "8255", NULL, "PortC",		"0x%02X",	PortC );
	Ini->PutEntry( "8255", NULL, "PortAbuf",	"0x%02X",	PortAbuf );
	Ini->PutEntry( "8255", NULL, "ModeA",		"%d",		ModeA );
	Ini->PutEntry( "8255", NULL, "ModeB",		"%d",		ModeB );
	Ini->PutEntry( "8255", NULL, "PortAdir",	"%s",		PortAdir ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "PortBdir",	"%s",		PortBdir ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "PortC1dir",	"%s",		PortC1dir ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "PortC2dir",	"%s",		PortC2dir ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSINT0",		"%s",		HSINT0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSWINT0",		"%s",		HSWINT0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSRINT0",		"%s",		HSRINT0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSSTB0",		"%s",		HSSTB0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSIBF0",		"%s",		HSIBF0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSDAK0",		"%s",		HSDAK0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSOBF0",		"%s",		HSOBF0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "RIE0",		"%s",		RIE0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "WIE0",		"%s",		WIE0 ? "Yes" : "No" );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ǂłLOAD
//
// :	Ini		INIIuWFNg|C^
// Ԓl:	BOOL	TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL PIO6::DokoLoad( cIni *Ini )
{
	int st;
	
	if( !Ini ) return FALSE;
	
	Ini->GetInt(   "8255", "PortA",		&st,		PortA );	PortA = st;
	Ini->GetInt(   "8255", "PortB",		&st,		PortB );	PortB = st;
	Ini->GetInt(   "8255", "PortC",		&st,		PortC );	PortC = st;
	Ini->GetInt(   "8255", "PortAbuf",	&st,		PortAbuf );	PortAbuf = st;
	Ini->GetInt(   "8255", "ModeA",		&ModeA,		ModeA );
	Ini->GetInt(   "8255", "ModeA",		&ModeB,		ModeB );
	Ini->GetTruth( "8255", "PortAdir",	&PortAdir,	PortAdir );
	Ini->GetTruth( "8255", "PortBdir",	&PortBdir,	PortBdir );
	Ini->GetTruth( "8255", "PortC1dir",	&PortC1dir,	PortC1dir );
	Ini->GetTruth( "8255", "PortC2dir",	&PortC2dir,	PortC2dir );
	Ini->GetTruth( "8255", "HSINT0",	&HSINT0,	HSINT0 );
	Ini->GetTruth( "8255", "HSWINT0",	&HSWINT0,	HSWINT0 );
	Ini->GetTruth( "8255", "HSRINT0",	&HSRINT0,	HSRINT0 );
	Ini->GetTruth( "8255", "HSSTB0",	&HSSTB0,	HSSTB0 );
	Ini->GetTruth( "8255", "HSIBF0",	&HSIBF0,	HSIBF0 );
	Ini->GetTruth( "8255", "HSDAK0",	&HSDAK0,	HSDAK0 );
	Ini->GetTruth( "8255", "HSOBF0",	&HSOBF0,	HSOBF0 );
	Ini->GetTruth( "8255", "RIE0",		&RIE0,	RIE0 );
	Ini->GetTruth( "8255", "WIE0",		&WIE0,	WIE0 );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
//  device description
////////////////////////////////////////////////////////////////
const Device::Descriptor PIO6::descriptor = {
	PIO6::indef, PIO6::outdef
};

const Device::OutFuncPtr PIO6::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &PIO6::Out90H ),
	STATIC_CAST( Device::OutFuncPtr, &PIO6::Out91H ),
	STATIC_CAST( Device::OutFuncPtr, &PIO6::Out92H ),
	STATIC_CAST( Device::OutFuncPtr, &PIO6::Out93H ),
	STATIC_CAST( Device::OutFuncPtr, &PIO6::OutPBH )
};

const Device::InFuncPtr PIO6::indef[] = {
	STATIC_CAST( Device::InFuncPtr, &PIO6::In90H ),
	STATIC_CAST( Device::InFuncPtr, &PIO6::In92H ),
	STATIC_CAST( Device::InFuncPtr, &PIO6::In93H ),
	STATIC_CAST( Device::InFuncPtr, &PIO6::InPBH ),
	STATIC_CAST( Device::InFuncPtr, &PIO6::InIBF ),
	STATIC_CAST( Device::InFuncPtr, &PIO6::InOBF )
};
